#include <stdio.h>
#include <stdlib.h>
#include <math.h>

int main()
{
    int n,x;
    int A[n],max=-pow(10,8),min=pow(10,8),t;
    scanf("%d %d",&x,&n);
    for (int i=0;i<=n;i++)
        scanf("%d",&A[i]);
    for (int i=0;i<=n;i++)
    {
        if (A[i]>max)
            max=A[i];
        if (A[i]<min)
            min=A[i];
    }
    if (x>max)
    {
        t=x-min;
        printf("%d",t);
    }
    else
    {
        if (x<min)
    {
        t=max-x;
        printf("%d",&x);
    }
        if (x-min>max-x)
        {
            t=x-min+max;
            printf("%d",&t);
        }
        else
        {
            t=max-x+min;
            printf("%d",&t);
        }

    }


    return 0;
}